/*=============================================================================================*/
/* Name        :                                                                               */
/* Author      :                                                                               */
/* Revision    : $Revision: #1 $                                                                    */
/*                                                                                             */
/* Copyright 2009-2020 ECMWF.                                                                  */
/* This software is licensed under the terms of the Apache Licence version 2.0                 */
/* which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.                        */
/* In applying this licence, ECMWF does not waive the privileges and immunities                */
/* granted to it by virtue of its status as an intergovernmental organisation                  */
/* nor does it submit to any jurisdiction.                                                     */
/*                                                                                             */
/* Description :                                                                               */
/*=============================================================================================*/

#include "pixmap.h"
/* XPM */
static const char * bits[] = {
"16 16 128 2",
"  	c #E5E5E5",
". 	c #D6D8BA",
"+ 	c #C2BF70",
"@ 	c #B6B04A",
"# 	c #A89D12",
"$ 	c #A89B12",
"% 	c #E7E377",
"& 	c #F3F489",
"* 	c #F4F387",
"= 	c #F4F484",
"- 	c #F2F381",
"; 	c #F0F37E",
"> 	c #F0F37B",
", 	c #EFF379",
"' 	c #EFF376",
") 	c #EDF373",
"! 	c #EDF271",
"~ 	c #E0E35F",
"{ 	c #B7B14A",
"] 	c #F1F58F",
"^ 	c #ECF277",
"/ 	c #E3EE5D",
"( 	c #E2ED5C",
"_ 	c #E1EC5B",
": 	c #DFEA59",
"< 	c #DDE858",
"[ 	c #DCE756",
"} 	c #DAE654",
"| 	c #D9E453",
"1 	c #E1EA64",
"2 	c #E9F274",
"3 	c #C7C46C",
"4 	c #F0F592",
"5 	c #E1EF66",
"6 	c #DFEE62",
"7 	c #F4F8CD",
"8 	c #E3EE78",
"9 	c #D6E852",
"0 	c #D5E651",
"a 	c #DEE975",
"b 	c #F2F6CB",
"c 	c #D6E35C",
"d 	c #D2E154",
"e 	c #E6F278",
"f 	c #C3C054",
"g 	c #EEF491",
"h 	c #E1EE66",
"i 	c #F6F9CE",
"j 	c #FFFFFF",
"k 	c #FDF8F5",
"l 	c #E0EC77",
"m 	c #DFEA77",
"n 	c #F1F5CC",
"o 	c #CEDE4F",
"p 	c #E5F276",
"q 	c #C3C051",
"r 	c #ECF48E",
"s 	c #DFED64",
"t 	c #E2EE79",
"u 	c #DCE675",
"v 	c #E5F274",
"w 	c #F0F386",
"x 	c #E5E750",
"y 	c #DFE340",
"z 	c #E6E767",
"A 	c #FDF7F3",
"B 	c #DFDE63",
"C 	c #D6D73B",
"D 	c #D3D539",
"E 	c #E7EF69",
"F 	c #C2BE4E",
"G 	c #F0ED7A",
"H 	c #E3E049",
"I 	c #DEDB38",
"J 	c #E4E063",
"K 	c #DDD960",
"L 	c #D3CD33",
"M 	c #D1CC31",
"N 	c #EAEC5C",
"O 	c #C0BB47",
"P 	c #EFE976",
"Q 	c #E1DD48",
"R 	c #E3DF62",
"S 	c #FCF7F3",
"T 	c #DBD65F",
"U 	c #D0CA31",
"V 	c #EAEB56",
"W 	c #BEB73C",
"X 	c #EFEA73",
"Y 	c #DFDB46",
"Z 	c #F3F2C5",
"` 	c #DEDB60",
" .	c #F0EEC4",
"..	c #CFC930",
"+.	c #E9EB52",
"@.	c #BEB83A",
"#.	c #EFEB70",
"$.	c #DDD943",
"%.	c #DAD643",
"&.	c #D5D134",
"*.	c #D4D033",
"=.	c #D2CC40",
"-.	c #D1CD34",
";.	c #E7EA4F",
">.	c #BEB739",
",.	c #BCB656",
"'.	c #EEEA6D",
").	c #E5E157",
"!.	c #DAD63E",
"~.	c #D5D034",
"{.	c #D2CD31",
"].	c #D1CB31",
"^.	c #D3CF36",
"/.	c #DFDE43",
"(.	c #E8EA4C",
"_.	c #C7C369",
":.	c #CBC888",
"<.	c #E1DD5B",
"[.	c #EEEB68",
"}.	c #EEEB65",
"|.	c #EDEB62",
"1.	c #EDEB5F",
"2.	c #ECEA5C",
"3.	c #ECEB59",
"4.	c #DCDD3F",
"5.	c #E0E0D0",
"6.	c #CBC789",
"7.	c #BDB658",
"                                ",
"  . + @ # # # # # # $ # @ + .   ",
"  + % & * = - ; > , ' ) ! ~ +   ",
"  { ] ^ / ( _ : < [ } | 1 2 3   ",
"  $ 4 5 6 7 8 9 0 a b c d e f   ",
"  # g h i j k l m k j n o p q   ",
"  # r s t k j k k j k u o v q   ",
"  # w x y z A j j A B C D E F   ",
"  # G H I J A j j A K L M N O   ",
"  # P Q R A j A A j S T U V W   ",
"  # X Y Z j A ` K S j  ...+.@.  ",
"  # #.$.%.Z K &.*.T  .=.-.;.>.  ",
"  ,.'.).!.~.*.L {.]...^./.(._.  ",
"  :.<.[.}.|.1.2.3.V +.;.(.4.:.  ",
"  5.6.7.$ # # $ # # # $ 7.6.5.  ",
"                                "};
static pixmap p("defstatus",(const char**)bits);
